/************************************************************************************/
/*  Copyright (C)           Microcyber Inc. All Rights Reserved                     */
/*  Product:                NCS-IF105 Profibus PA                                   */
/*                                                                                  */
/*  Device:                 NCS-IF105 Current to Fieldbus Converter for PROFIBUS PA */
/*  Description:            Device Description File                                 */
/*  Dictionary:             SIPADC01.dct                                            */
/*                                                                                  */
/*  Revision:  1.0                                                                  */
/*  Date:      2009-11-25                                                           */
/*  Author:    Ning Dekui                                                           */
/************************************************************************************/
MANUFACTURER            0x16c,
DEVICE_TYPE             0x01,
DEVICE_REVISION         0x01,
DD_REVISION             0x01

#define _NCS_IF
#define DEVICE_TYPE "NCS_IF105"

#include "SI_FileM.inc"
#include "SI_HlpM.inc"
#include "SI_OptM.inc"
#include "SIPAST_CommError.inc"

/*
#include "SI_MainMenu.inc"
#include "SI_ViewM.inc"
*/

#include "defmacros.inc"
#include "Phys_Blk.inc"
#include "AI4_Blk1.inc"
#include "MC_YT.inc" 

/***********************************************************************/
/*****    Menu: Specialist  **********************************************/
/***********************************************************************/

MENU Menu_Main_Specialist
{
    LABEL        [main_menu];
    ITEMS
    {
        Menu_File,
        Menu_S_Device,
        Menu_S_View,
        Menu_Options,
        Menu_Help
    }
}

/***********************************************************************/
/*****    Menu: Maintenance  *********************************************/
/***********************************************************************/

MENU Menu_Main_Maintenance
{
    LABEL        [main_menu];
    ITEMS
    {
        Menu_File,
        Menu_M_Device,
        Menu_M_View,
        Menu_Options,
        Menu_Help
    }
}

//MENU download_variables
//{
//    LABEL        [menu_load_to_PC];
//    ITEMS
//    {
//    /* PHYSICAL BLOCK    */
//        phys_st_rev,
//        phys_device_man_id,
//        phys_device_id,
//        phys_tag_desc,
//        phys_descriptor,
//        phys_message,
//        phys_install_date,
//        phys_software_rev,
//        phys_hardware_rev,
//        phys_blk_profile,
//        phys_blk_profile_rev,
//        phys_blk_dd_reference,
//        phys_blk_dd_rev,
//        phys_device_certification,
//        phys_device_ser_num,
//
//
//
//    /* TRANDSDUCER BLOCK 1    */
//        trans1_TT_1_st_rev,
//
//    /* TRANDSDUCER BLOCK 2    */
//        trans1_TT_2_st_rev,
//
//    /* FUNCTION BLOCK 1: AI    */
//        func1_AI_st_rev,
//        func1_AI_tag_desc,
//        func1_AI_batch_id,
//        func1_AI_batch_unit,
//        func1_AI_batch_operation,
//        func1_AI_batch_phase,
//        func1_AI_channel,
//        func1_AI_pv_ftime,
//        func1_AI_target_mode,
//        func1_AI_pv_lower_range_value,
//        func1_AI_pv_upper_range_value,
//        func1_AI_out_lower_range_value,
//        func1_AI_out_upper_range_value,
//        func1_AI_out_unit,
//        func1_AI_out_decimal_point,
//        func1_AI_hi_hi_lim,
//        func1_AI_hi_lim,
//        func1_AI_lo_lim,
//        func1_AI_lo_lo_lim,
//        func1_AI_alarm_hys,
//        func1_AI_FSafeType,
//        func1_AI_FSafeValue, 
//    }
//}

MENU upload_variables
{
    LABEL        [menu_load_to_device];
    ITEMS
    {
    /* PHYSICAL BLOCK    */
        phys_tag_desc,
        phys_descriptor,
        phys_message,
        phys_install_date,
        //phys_ident_number,
        //phys_write_locking,
        phys_local_operation_enable,
        phys_strategy,
        phys_alert_key,
        phys_lcd_dsp_channel,

//    /* TRANDSDUCER BLOCK 1: */
//        trans1_TT_1_st_rev,
//        trans1_TT_1_tag_desc,
//        trans1_TT_1_st_rev,
//        trans1_TT_1_lin_type,
//        trans1_TT_1_primary_value_unit,
//        trans1_TT_1_sensor_measure_type,
//        IF (trans1_TT_1_lin_type == 0)
//        {    trans1_TT_1_input_range,}
//        IF ((trans1_TT_1_lin_type == 128) || (trans1_TT_1_lin_type == 131) || 
//            ((trans1_TT_1_lin_type >= 133) && (trans1_TT_1_lin_type <= 138)))
//        {   trans1_TT_1_rj_type,}
//        trans1_TT_1_bias_1,
//        trans1_TT_1_bias_2,
//        trans1_TT_1_sensor_connection,
////        trans1_TT_1_sensor_wire_check_1,
////        trans1_TT_1_sensor_wire_check_2,
//        trans1_TT_1_lower_sensor_limit,
//        trans1_TT_1_upper_sensor_limit,
//        //trans1_TT_1_Channel
//    
//    /* TRANDSDUCER BLOCK 2: */
//        trans1_TT_2_st_rev,
//        trans1_TT_2_tag_desc,
//        trans1_TT_2_st_rev,
//        trans1_TT_2_lin_type,
//        trans1_TT_2_primary_value_unit,
//        trans1_TT_2_sensor_measure_type,
//        IF (trans1_TT_2_lin_type == 0)
//        {    trans1_TT_2_input_range,}
//        IF ((trans1_TT_2_lin_type == 128) || (trans1_TT_2_lin_type == 131) || 
//            ((trans1_TT_2_lin_type >= 133) && (trans1_TT_2_lin_type <= 138)))
//        {   trans1_TT_2_rj_type,}
//        trans1_TT_2_bias_1,
//        trans1_TT_2_bias_2,
//        trans1_TT_2_sensor_connection,
////        trans1_TT_2_sensor_wire_check_1,
////        trans1_TT_2_sensor_wire_check_2,
//        trans1_TT_2_lower_sensor_limit,
//        trans1_TT_2_upper_sensor_limit,
//        //trans1_TT_2_Channel

    /* FUNCTION BLOCK 1: AI 1    */
        func1_AI_1_tag_desc,
        func1_AI_1_strategy,
        func1_AI_1_alert_key,
        func1_AI_1_target_mode,
        func1_AI_1_batch_id,
        func1_AI_1_batch_unit,
        func1_AI_1_batch_operation,
        func1_AI_1_batch_phase,
        func1_AI_1_channel,
        func1_AI_1_lin_type,
        func1_AI_1_pv_ftime,
        func1_AI_1_pv_upper_range_value,
        func1_AI_1_pv_lower_range_value,
        func1_AI_1_out_upper_range_value,
        func1_AI_1_out_lower_range_value,
        func1_AI_1_out_unit,
        func1_AI_1_out_decimal_point,
        func1_AI_1_alarm_hys,
        func1_AI_1_hi_hi_lim,
        func1_AI_1_hi_lim,
        func1_AI_1_lo_lim,
        func1_AI_1_lo_lo_lim,
        func1_AI_1_FSafeType,
        func1_AI_1_FSafeValue,
        func1_AI_1_out_unit_text,

    /* FUNCTION BLOCK 1: AI 2    */
        func1_AI_2_tag_desc,
        func1_AI_2_strategy,
        func1_AI_2_alert_key,
        func1_AI_2_target_mode,
        func1_AI_2_batch_id,
        func1_AI_2_batch_unit,
        func1_AI_2_batch_operation,
        func1_AI_2_batch_phase,
        func1_AI_2_channel,
        func1_AI_2_lin_type,
        func1_AI_2_pv_ftime,
        func1_AI_2_pv_upper_range_value,
        func1_AI_2_pv_lower_range_value,
        func1_AI_2_out_upper_range_value,
        func1_AI_2_out_lower_range_value,
        func1_AI_2_out_unit,
        func1_AI_2_out_decimal_point,
        func1_AI_2_alarm_hys,
        func1_AI_2_hi_hi_lim,
        func1_AI_2_hi_lim,
        func1_AI_2_lo_lim,
        func1_AI_2_lo_lo_lim,
        func1_AI_2_FSafeType,
        func1_AI_2_FSafeValue,
        func1_AI_2_out_unit_text,

    /* FUNCTION BLOCK 1: AI 3    */
        func1_AI_3_tag_desc,
        func1_AI_3_strategy,
        func1_AI_3_alert_key,
        func1_AI_3_target_mode,
        func1_AI_3_batch_id,
        func1_AI_3_batch_unit,
        func1_AI_3_batch_operation,
        func1_AI_3_batch_phase,
        func1_AI_3_channel,
        func1_AI_3_lin_type,
        func1_AI_3_pv_ftime,
        func1_AI_3_pv_upper_range_value,
        func1_AI_3_pv_lower_range_value,
        func1_AI_3_out_upper_range_value,
        func1_AI_3_out_lower_range_value,
        func1_AI_3_out_unit,
        func1_AI_3_out_decimal_point,
        func1_AI_3_alarm_hys,
        func1_AI_3_hi_hi_lim,
        func1_AI_3_hi_lim,
        func1_AI_3_lo_lim,
        func1_AI_3_lo_lo_lim,
        func1_AI_3_FSafeType,
        func1_AI_3_FSafeValue,
        func1_AI_3_out_unit_text,

    /* FUNCTION BLOCK 1: AI 4    */
        func1_AI_4_tag_desc,
        func1_AI_4_strategy,
        func1_AI_4_alert_key,
        func1_AI_4_target_mode,
        func1_AI_4_batch_id,
        func1_AI_4_batch_unit,
        func1_AI_4_batch_operation,
        func1_AI_4_batch_phase,
        func1_AI_4_channel,
        func1_AI_4_lin_type,
        func1_AI_4_pv_ftime,
        func1_AI_4_pv_upper_range_value,
        func1_AI_4_pv_lower_range_value,
        func1_AI_4_out_upper_range_value,
        func1_AI_4_out_lower_range_value,
        func1_AI_4_out_unit,
        func1_AI_4_out_decimal_point,
        func1_AI_4_alarm_hys,
        func1_AI_4_hi_hi_lim,
        func1_AI_4_hi_lim,
        func1_AI_4_lo_lim,
        func1_AI_4_lo_lo_lim,
        func1_AI_4_FSafeType,
        func1_AI_4_FSafeValue,
        func1_AI_4_out_unit_text
    }
    PRE_READ_ACTIONS
    {
        method_pre_write_phys_write_locking
    }
}




/*---------------------------------------------------------------------*/
/*    Menu: Device                                                     */
/*---------------------------------------------------------------------*/

MENU Menu_S_Device
{
    LABEL        [menu_Device];
    ITEMS
    {
        std_NodeAddress,
        SEPARATOR,
        std_LoadinDevice,
        std_LoadinPC,
        SEPARATOR,
        Menu_online,
        Menu_offline,
        SEPARATOR,
//        Menu_cal,
        OnlineWindow_simulation,
        SEPARATOR,
        OnlineDialog_reset,
        OnlineDialog_write_locking,
        OnlineDialog_ident_number
    }
}

MENU Menu_M_Device
{
    LABEL        [menu_Device];
    ITEMS
    {
        std_NodeAddress,
        SEPARATOR,
        std_LoadinDevice,
        std_LoadinPC//,
//        SEPARATOR,
//        Menu_online,
//        Menu_offline,
//        Menu_cal,
    }
}

MENU Menu_online
{
    LABEL [MC_Online_Conf];
    ITEMS
    {
        Menu_func1_AI_1_online,
        Menu_func1_AI_2_online,
        Menu_func1_AI_3_online,
        Menu_func1_AI_4_online
    }
}

MENU Menu_offline
{
    LABEL [MC_Offline_Conf];
    ITEMS
    {
//        OfflineWindow_trans1_TT_1_setting,
//        OfflineWindow_trans1_TT_2_setting,
        OfflineWindow_AI_1_geral,
        OfflineWindow_AI_2_geral,
        OfflineWindow_AI_3_geral,
        OfflineWindow_AI_4_geral,
        OfflineWindow_LCD_display
    }
}

//MENU OfflineWindow_trans1_TT_1_setting
//{
//    LABEL [trans1];
//    ITEMS
//    {
//        Page_trans1_TT_1_Basic_Settings,
//        Page_trans1_TT_1_Advanced_Settings
//    }
//}
//
//MENU Page_trans1_TT_1_Basic_Settings
//{
//    LABEL [MC_Tab_basic];
//    ITEMS
//    {
//        Group_trans1_TT_1_Measure_Type,
//        Group_trans1_TT_1_Sensor_Type,
//        Group_trans1_TT_1_Connection_Type,
//        Group_trans1_TT_1_RJ_Type
//    }
//}
//
//MENU Group_trans1_TT_1_Measure_Type
//{
//    LABEL [MC_Select_Measure_Type];
//    ITEMS
//    {
//        trans1_TT_1_sensor_measure_type,
//        SEPARATOR,
//        method_write_trans1_TT_1_sensor_measure_type
//    }
//}
//
//MENU Group_trans1_TT_1_Sensor_Type
//{
//    LABEL [MC_Select_Sensor_Type];
//    ITEMS
//    {
//        trans1_TT_1_lin_type,
//        trans1_TT_1_input_range,
//        SEPARATOR,
//        method_write_trans1_TT_1_Sensor_type
//    }
//}
//
//MENU Group_trans1_TT_1_Connection_Type
//{
//    LABEL [MC_Select_Connection_Type];
//    ITEMS
//    {
//        trans1_TT_1_sensor_connection,
//        SEPARATOR,
//        method_write_trans1_TT_1_sensor_connection
//    }
//    VALIDITY    IF ((trans1_TT_1_lin_type == 102) || (trans1_TT_1_lin_type == 105) || 
//                    (trans1_TT_1_lin_type == 240) || (trans1_TT_1_lin_type == 127) ||
//                    (trans1_TT_1_lin_type == 0))
//                {   
//                    TRUE;
//                }
//                ELSE
//                {
//                    FALSE;
//                }
//}
//
//MENU Group_trans1_TT_1_RJ_Type
//{
//    LABEL [MC_Select_RJ_Type];
//    ITEMS
//    {
//        trans1_TT_1_rj_type,
//        SEPARATOR,
//        method_write_trans1_TT_1_rj_type
//    }
//    VALIDITY    IF ((trans1_TT_1_lin_type == 102) || (trans1_TT_1_lin_type == 105) || 
//                    (trans1_TT_1_lin_type == 240) || (trans1_TT_1_lin_type == 127) ||
//                    (trans1_TT_1_lin_type == 0))
//                {   
//                    FALSE;
//                }
//                ELSE
//                {
//                    TRUE;
//                }
//}
//
//MENU OfflineWindow_trans1_TT_2_setting
//{
//    LABEL [trans2];
//    ITEMS
//    {
//        Page_trans1_TT_2_Basic_Settings,
//        Page_trans1_TT_2_Advanced_Settings
//    }
//}
//
//MENU Page_trans1_TT_2_Basic_Settings
//{
//    LABEL [MC_Tab_basic];
//    ITEMS
//    {
//        Group_trans1_TT_2_Measure_Type,
//        Group_trans1_TT_2_Sensor_Type,
//        Group_trans1_TT_2_Connection_Type,
//        Group_trans1_TT_2_RJ_Type
//    }
//}
//
//MENU Group_trans1_TT_2_Measure_Type
//{
//    LABEL [MC_Select_Measure_Type];
//    ITEMS
//    {
//        trans1_TT_2_sensor_measure_type,
//        SEPARATOR,
//        method_write_trans1_TT_2_sensor_measure_type
//    }
//}
//
//MENU Group_trans1_TT_2_Sensor_Type
//{
//    LABEL [MC_Select_Sensor_Type];
//    ITEMS
//    {
//        trans1_TT_2_lin_type,
//        trans1_TT_2_input_range,
//        SEPARATOR,
//        method_write_trans1_TT_2_Sensor_type
//    }
//}
//
//MENU Group_trans1_TT_2_Connection_Type
//{
//    LABEL [MC_Select_Connection_Type];
//    ITEMS
//    {
//        trans1_TT_2_sensor_connection,
//        SEPARATOR,
//        method_write_trans1_TT_2_sensor_connection
//    }
//    VALIDITY    IF ((trans1_TT_2_lin_type == 102) || (trans1_TT_2_lin_type == 105) || 
//                    (trans1_TT_2_lin_type == 240) || (trans1_TT_2_lin_type == 127) ||
//                    (trans1_TT_2_lin_type == 0))
//                {   
//                    TRUE;
//                }
//                ELSE
//                {
//                    FALSE;
//                }
//}
//
//MENU Group_trans1_TT_2_RJ_Type
//{
//    LABEL [MC_Select_RJ_Type];
//    ITEMS
//    {
//        trans1_TT_2_rj_type,
//        SEPARATOR,
//        method_write_trans1_TT_2_rj_type
//    }
//    VALIDITY    IF ((trans1_TT_2_lin_type == 102) || (trans1_TT_2_lin_type == 105) || 
//                    (trans1_TT_2_lin_type == 240) || (trans1_TT_2_lin_type == 127) ||
//                    (trans1_TT_2_lin_type == 0))
//                {   
//                    FALSE;
//                }
//                ELSE
//                {
//                    TRUE;
//                }
//}





//MENU Page_trans1_TT_1_Advanced_Settings
//{
//    LABEL [MC_Tab_advanced];
//    ITEMS
//    {
//        Group_trans1_TT_1_primary_value_unit,
//        Group_trans1_TT_1_bias_of_channel,
//        Group_trans1_TT_1_2wire_compensation,
////        Group_trans1_TT_1_sensor_wire_check,
//        Group_trans1_TT_1_sensor_limit
//    }
//}
//
//MENU Group_trans1_TT_1_primary_value_unit
//{
//    LABEL [MC_Select_Output_Unit];
//    ITEMS
//    {
//        trans1_TT_1_primary_value_unit,
//        SEPARATOR,
//        method_write_trans1_TT_1_primary_value_unit
//    }
//}
//
//MENU Group_trans1_TT_1_bias_of_channel
//{
//    LABEL [MC_Set_Bias_of_Channel];
//    ITEMS
//    {
//        trans1_TT_1_bias_1,
//        trans1_TT_1_bias_2,
//        SEPARATOR,
//        method_write_trans1_TT_1_bias_1,
//        method_write_trans1_TT_1_bias_2
//    }
//}
//
//MENU Group_trans1_TT_1_2wire_compensation
//{
//    LABEL [MC_Set_2Wire_Comp];
//    ITEMS
//    {
////        trans1_TT_1_Channel,
////        SEPARATOR,
//        method_set_trans1_TT_1_two_Wires_Comp
//    }
//}
//
////MENU Group_trans1_TT_1_sensor_wire_check
////{
////    LABEL [MC_Set_Sensor_Wire_Check];
////    ITEMS
////    {
////        trans1_TT_1_sensor_wire_check_1,
////        trans1_TT_1_sensor_wire_check_2,
////        SEPARATOR,
////        method_write_trans1_TT_1_sensor_wire_check_1,
////        method_write_trans1_TT_1_sensor_wire_check_2
////    }
////}
//
//MENU Group_trans1_TT_1_sensor_limit
//{
//    LABEL [MC_Sensor_Limits];
//    ITEMS
//    {
//        trans1_TT_1_lower_sensor_limit,
//        trans1_TT_1_upper_sensor_limit
//    }
//}
//
//MENU Page_trans1_TT_2_Advanced_Settings
//{
//    LABEL [MC_Tab_advanced];
//    ITEMS
//    {
//        Group_trans1_TT_2_primary_value_unit,
//        Group_trans1_TT_2_bias_of_channel,
//        Group_trans1_TT_2_2wire_compensation,
////        Group_trans1_TT_2_sensor_wire_check,
//        Group_trans1_TT_2_sensor_limit
//    }
//}
//
//MENU Group_trans1_TT_2_primary_value_unit
//{
//    LABEL [MC_Select_Output_Unit];
//    ITEMS
//    {
//        trans1_TT_2_primary_value_unit,
//        SEPARATOR,
//        method_write_trans1_TT_2_primary_value_unit
//    }
//}
//
//MENU Group_trans1_TT_2_bias_of_channel
//{
//    LABEL [MC_Set_Bias_of_Channel];
//    ITEMS
//    {
//        trans1_TT_2_bias_1,
//        trans1_TT_2_bias_2,
//        SEPARATOR,
//        method_write_trans1_TT_2_bias_1,
//        method_write_trans1_TT_2_bias_2
//    }
//}
//
//MENU Group_trans1_TT_2_2wire_compensation
//{
//    LABEL [MC_Set_2Wire_Comp];
//    ITEMS
//    {
////        trans1_TT_2_Channel,
////        SEPARATOR,
//        method_set_trans1_TT_2_two_Wires_Comp
//    }
//}
//
////MENU Group_trans1_TT_2_sensor_wire_check
////{
////    LABEL [MC_Set_Sensor_Wire_Check];
////    ITEMS
////    {
////        trans1_TT_2_sensor_wire_check_1,
////        trans1_TT_2_sensor_wire_check_2,
////        SEPARATOR,
////        method_write_trans1_TT_2_sensor_wire_check_1,
////        method_write_trans1_TT_2_sensor_wire_check_2
////    }
////}
//
//MENU Group_trans1_TT_2_sensor_limit
//{
//    LABEL [MC_Sensor_Limits];
//    ITEMS
//    {
//        trans1_TT_2_lower_sensor_limit,
//        trans1_TT_2_upper_sensor_limit
//    }
//}
//
//MENU Menu_cal
//{
//    LABEL        [MC_menu_cal];
//    ITEMS
//    {
//        OnlineDialog_trans1_TT_1_cal,
//        OnlineDialog_trans1_TT_2_cal
//    }
//}
//
//MENU OnlineDialog_trans1_TT_1_cal
//{
//    LABEL        [MC_cal_trd1];
//    ITEMS
//    {
//        Page_trans1_TT_1_cal_para,
//        Page_trans1_TT_1_cal_lo_point,
//        Page_trans1_TT_1_cal_hi_point
//    }
//}
//
//MENU Page_trans1_TT_1_cal_para
//{
//    LABEL     [MC_cal_para];
//    ITEMS
//    {
////        trans1_TT_1_Channel,
//        trans1_TT_1_Cal_Unit,
//        trans1_TT_1_lin_type,
//        trans1_TT_1_input_range,
//        SEPARATOR,
//        method_set
//    }
//}
//
//MENU Page_trans1_TT_1_cal_lo_point
//{
//    LABEL     [MC_cal_lo_point];
//    ITEMS
//    {
//        trans1_TT_1_lower_sensor_limit (READ_ONLY),
//        trans1_TT_1_Cal_Point_Lo (READ_ONLY),
//        trans1_TT_1_Sensor_Value_1,
//        //trans1_TT_1_Sensor_Value_2,
//        SEPARATOR,
//        method_set_trans1_TT_1_cal_point_lo
//    }
//}
//
//MENU Page_trans1_TT_1_cal_hi_point
//{
//    LABEL     [MC_cal_hi_point];
//    ITEMS
//    {
//        trans1_TT_1_upper_sensor_limit (READ_ONLY),
//        trans1_TT_1_Cal_Point_Hi (READ_ONLY),
//        trans1_TT_1_Sensor_Value_1,
//        //trans1_TT_1_Sensor_Value_2,
//        SEPARATOR,
//        method_set_trans1_TT_1_cal_point_hi
//    }
//}
//
//
//MENU OnlineDialog_trans1_TT_2_cal
//{
//    LABEL        [MC_cal_trd2];
//    ITEMS
//    {
//        Page_trans1_TT_2_cal_para,
//        Page_trans1_TT_2_cal_lo_point,
//        Page_trans1_TT_2_cal_hi_point
//    }
//}
//
//MENU Page_trans1_TT_2_cal_para
//{
//    LABEL     [MC_cal_para];
//    ITEMS
//    {
////        trans1_TT_2_Channel,
//        trans1_TT_2_Cal_Unit,
//        trans1_TT_2_lin_type,
//        trans1_TT_2_input_range,
//        SEPARATOR,
//        method_set
//    }
//}
//
//MENU Page_trans1_TT_2_cal_lo_point
//{
//    LABEL     [MC_cal_lo_point];
//    ITEMS
//    {
//        trans1_TT_2_lower_sensor_limit (READ_ONLY),
//        trans1_TT_2_Cal_Point_Lo (READ_ONLY),
//        //trans1_TT_2_Sensor_Value_1,
//        trans1_TT_2_Sensor_Value_2,
//        SEPARATOR,
//        method_set_trans1_TT_2_cal_point_lo
//    }
//}
//
//MENU Page_trans1_TT_2_cal_hi_point
//{
//    LABEL     [MC_cal_hi_point];
//    ITEMS
//    {
//        trans1_TT_2_upper_sensor_limit (READ_ONLY),
//        trans1_TT_2_Cal_Point_Hi (READ_ONLY),
//        //trans1_TT_2_Sensor_Value_1,
//        trans1_TT_2_Sensor_Value_2,
//        SEPARATOR,
//        method_set_trans1_TT_2_cal_point_hi
//    }
//}

MENU OnlineWindow_simulation
{
    LABEL        [menu_dialog_simulation];
    ITEMS
    {
        Page_simulation_input_func1_AI_1,
        Page_simulation_input_func1_AI_2,
        Page_simulation_input_func1_AI_3,
        Page_simulation_input_func1_AI_4,
        Page_simulation_output_func1_AI_1,
        Page_simulation_output_func1_AI_2,
        Page_simulation_output_func1_AI_3,
        Page_simulation_output_func1_AI_4
    }
}

/*---------------------------------------------------------------------*/
/*    Menu: View                                                       */
/*---------------------------------------------------------------------*/
MENU Menu_S_View
{
    LABEL        [menu_View];
    ITEMS
    {
        OnlineWindow_display,
        SEPARATOR,
        OnlineWindow_yt,
        Menu_S_alarm,
        OnlineWindow_diagnosis
        SEPARATOR,
        std_Funktionsleiste,
        std_Statuszeile,
        SEPARATOR,
        std_Update     
    }
}

MENU OnlineWindow_display
{
    LABEL        [menu_dialog_display];
    ITEMS
    {
//        Page_display_trans1_TT_1,
//        Page_display_trans1_TT_2,
	    Page_display_func1_AI_1,
        Page_display_func1_AI_2,
	    Page_display_func1_AI_3,
        Page_display_func1_AI_4
    }
}
//
//MENU Page_display_trans1_TT_1
//{
//    LABEL        "Transducer 1";
//    ITEMS
//    {
//        BarVal_trans1_TT_1_display_measure,
//        Group_trans1_TT_1_display_Primary_Value,
//        Group_trans1_TT_1_display_Secondary_Value,
//    }
//}
//
//MENU BarVal_trans1_TT_1_display_measure
//{
//    LABEL        [menu_dialog_display_measure];
//    ITEMS
//    {
//        trans1_TT_1_primary_value         (READ_ONLY),
//        trans1_TT_1_lower_sensor_limit    (READ_ONLY),
//        trans1_TT_1_upper_sensor_limit    (READ_ONLY)
//    }
//}
//
//MENU Group_trans1_TT_1_display_Primary_Value
//{
//    LABEL        [MC_Primary_Value];
//    ITEMS
//    {
//        trans1_TT_1_primary_value                    (READ_ONLY),
//        SEPARATOR,
//        trans1_TT_1_primary_value_status_quality     (READ_ONLY),
//        trans1_TT_1_primary_value_status_limit        (READ_ONLY)
//    }
//}
//
//MENU Group_trans1_TT_1_display_Secondary_Value
//{
//    LABEL        [MC_Secondary_Value];
//    ITEMS
//    {
//        trans1_TT_1_secondary_value_1                     (READ_ONLY),
//        trans1_TT_1_secondary_value_2                     (READ_ONLY),
//        SEPARATOR,
//        trans1_TT_1_input_fault_1                         (READ_ONLY),
//        trans1_TT_1_input_fault_2                         (READ_ONLY),
//        trans1_TT_1_rj_temp                               (READ_ONLY),
////        trans1_TT_1_rj_type                               (READ_ONLY)
//    }
//}
//
//MENU Page_display_trans1_TT_2
//{
//    LABEL        "Transducer 2";
//    ITEMS
//    {
//        BarVal_trans1_TT_2_display_measure,
//        Group_trans1_TT_2_display_Primary_Value,
//        Group_trans1_TT_2_display_Secondary_Value,
//    }
//}
//
//MENU BarVal_trans1_TT_2_display_measure
//{
//    LABEL        [menu_dialog_display_measure];
//    ITEMS
//    {
//        trans1_TT_2_primary_value         (READ_ONLY),
//        trans1_TT_2_lower_sensor_limit    (READ_ONLY),
//        trans1_TT_2_upper_sensor_limit    (READ_ONLY)
//    }
//}
//
//MENU Group_trans1_TT_2_display_Primary_Value
//{
//    LABEL        [MC_Primary_Value];
//    ITEMS
//    {
//        trans1_TT_2_primary_value                    (READ_ONLY),
//        SEPARATOR,
//        trans1_TT_2_primary_value_status_quality     (READ_ONLY),
//        trans1_TT_2_primary_value_status_limit        (READ_ONLY)
//    }
//}
//
//MENU Group_trans1_TT_2_display_Secondary_Value
//{
//    LABEL        [MC_Secondary_Value];
//    ITEMS
//    {
//        trans1_TT_2_secondary_value_1                     (READ_ONLY),
//        trans1_TT_2_secondary_value_2                     (READ_ONLY),
//        SEPARATOR,
//        trans1_TT_2_input_fault_1                         (READ_ONLY),
//        trans1_TT_2_input_fault_2                         (READ_ONLY),
//        trans1_TT_2_rj_temp                               (READ_ONLY),
////        trans1_TT_2_rj_type                               (READ_ONLY)
//    }
//}

MENU Menu_S_alarm
{
    LABEL        [menu_dialog_alarm];
    ITEMS
    {
        OnlineWindow_S_alarm_func1_AI_1,
        OnlineWindow_S_alarm_func1_AI_2,
        OnlineWindow_S_alarm_func1_AI_3,
        OnlineWindow_S_alarm_func1_AI_4
    }
}

MENU OnlineWindow_diagnosis
{
    LABEL        [menu_dialog_diagnosis];
    ITEMS
    {
        Page_diagnosis_general,
        Page_diagnosis_phys_block,
//        Page_diagnosis_trans1_TT_1_block,
//        Page_diagnosis_trans1_TT_2_block,
        Page_diagnosis_func1_AI_1,
        Page_diagnosis_func1_AI_2,
        Page_diagnosis_func1_AI_3,
        Page_diagnosis_func1_AI_4
    }
}
//
//MENU Page_diagnosis_trans1_TT_1_block
//{
//    LABEL        [trans1_block];
//    ITEMS
//    {
//        trans1_TT_1_blk_object,
//        trans1_TT_1_blk_parent_class,
//        trans1_TT_1_blk_class,
//        trans1_TT_1_blk_dd_reference,
//        trans1_TT_1_blk_dd_rev,
//        trans1_TT_1_blk_profile,
//        trans1_TT_1_blk_profile_rev,
//        trans1_TT_1_st_rev,
//        trans1_TT_1_actual_mode
//    }
//}
//
//MENU Page_diagnosis_trans1_TT_2_block
//{
//    LABEL        [trans2_block];
//    ITEMS
//    {
//        trans1_TT_2_blk_object,
//        trans1_TT_2_blk_parent_class,
//        trans1_TT_2_blk_class,
//        trans1_TT_2_blk_dd_reference,
//        trans1_TT_2_blk_dd_rev,
//        trans1_TT_2_blk_profile,
//        trans1_TT_2_blk_profile_rev,
//        trans1_TT_2_st_rev,
//        trans1_TT_2_actual_mode
//    }
//}



/***********************************************************************/
/*****    Table: Specialist    *****************************************/
/***********************************************************************/

MENU Table_Main_Specialist
{
    LABEL    "NCS_IF105 (Specialist)";
    ITEMS
    {
        Tab_s_info,
//        Tab_s_trd,
        Tab_s_ai,
        Tab_s_lcd
    }
}

MENU Tab_s_info
{
    LABEL    [MC_Tab_info];
    ITEMS
    {
        Tab_s_manuf_info,       /* file Phys_Blk.inc */
        Tab_s_block_tag,
        Tab_s_get_info,         /* file Phys_Blk.inc */
        Tab_serial_numbers,
        Tab_device_revisions,   /* file Phys_Blk.inc */
        Tab_s_certificates      /* file Phys_Blk.inc */
    }
}

MENU Tab_s_block_tag
{
    LABEL    [MC_Tab_block_tag];
    ITEMS
    {
        phys_tag_desc,
//        trans1_TT_1_tag_desc,
//        trans1_TT_2_tag_desc,
        func1_AI_1_tag_desc,
        func1_AI_2_tag_desc
    }
}

MENU Tab_serial_numbers
{
    LABEL   [MC_Tab_serial_numbers];
    ITEMS
    {
        phys_device_ser_num   (READ_ONLY),
    }
}
//
//MENU Tab_s_trd_1
//{
//    LABEL   [trans1];
//    ITEMS
//    {
//        trans1_TT_1_st_rev,
//        trans1_TT_1_lin_type,
//        trans1_TT_1_primary_value_unit,
//        trans1_TT_1_sensor_measure_type,
//        trans1_TT_1_input_range,
//        trans1_TT_1_bias_1,
//        trans1_TT_1_bias_2,
//        trans1_TT_1_sensor_connection,
//        trans1_TT_1_rj_type,
///*        trans1_TT_1_comp_wire_1,
//        trans1_TT_1_comp_wire_2,  */
////        trans1_TT_1_sensor_wire_check_1,
////        trans1_TT_1_sensor_wire_check_2,
//        trans1_TT_1_lower_sensor_limit,
//        trans1_TT_1_upper_sensor_limit
//    }
//}
//
//MENU Tab_s_trd_2
//{
//    LABEL   [trans2];
//    ITEMS
//    {
//        trans1_TT_2_st_rev,
//        trans1_TT_2_lin_type,
//        trans1_TT_2_primary_value_unit,
//        trans1_TT_2_sensor_measure_type,
//        trans1_TT_2_input_range,
//        trans1_TT_2_bias_1,
//        trans1_TT_2_bias_2,
//        trans1_TT_2_sensor_connection,
//        trans1_TT_2_rj_type,
///*        trans1_TT_2_comp_wire_1,
//        trans1_TT_2_comp_wire_2,  */
////        trans1_TT_2_sensor_wire_check_1,
////        trans1_TT_2_sensor_wire_check_2,
//        trans1_TT_2_lower_sensor_limit,
//        trans1_TT_2_upper_sensor_limit
//    }
//}
//
//MENU Tab_s_trd
//{
//    LABEL   "Tansducer (2)";
//    ITEMS
//    {
//        Tab_s_trd_1,
//        Tab_s_trd_2
//    }
//}

MENU Tab_s_ai
{
    LABEL   "Analog Input (4)";
    ITEMS
    {
        Tab_s_AI_1,
        Tab_s_AI_2,
        Tab_s_AI_3,
        Tab_s_AI_4
    }
}

/******************************************************************************/
/*****    Table: Maintenance    ***********************************************/
/******************************************************************************/
MENU Table_Main_Maintenance
{
    LABEL    "NCS_IF105 (Maintenance)";
    ITEMS
    {
        Tab_m_info,
//        Tab_m_trd,
        Tab_m_AI,
//        Tab_m_lcd
    }
}

MENU Tab_m_info
{
    LABEL    [MC_Tab_info];
    ITEMS
    {
        Tab_m_manuf_info,       /* file Phys_Blk.inc */
        Tab_m_block_tag,
        Tab_m_get_info,         /* file Phys_Blk.inc */
        Tab_serial_numbers,     /* file Phys_Blk.inc */
        Tab_device_revisions,   /* file Phys_Blk.inc */
        Tab_m_certificates      /* file Phys_Blk.inc */
    }
}

MENU Tab_m_block_tag
{
    LABEL    [MC_Tab_block_tag];
    ITEMS
    {
        phys_tag_desc  (READ_ONLY),
//        trans1_TT_1_tag_desc  (READ_ONLY),
//        trans1_TT_2_tag_desc  (READ_ONLY),
        func1_AI_1_tag_desc  (READ_ONLY),
        func1_AI_2_tag_desc  (READ_ONLY),
        func1_AI_3_tag_desc  (READ_ONLY),
        func1_AI_4_tag_desc  (READ_ONLY)
    }
}
//
//MENU Tab_m_trd_1
//{
//    LABEL   [trans1];
//    ITEMS
//    {
//        trans1_TT_1_st_rev,
//        trans1_TT_1_lin_type  (READ_ONLY),
//        trans1_TT_1_primary_value_unit  (READ_ONLY),
//        trans1_TT_1_sensor_measure_type  (READ_ONLY),
//        trans1_TT_1_input_range  (READ_ONLY),
//        trans1_TT_1_lower_sensor_limit  (READ_ONLY),
//        trans1_TT_1_upper_sensor_limit  (READ_ONLY)
//    }
//}
//
//MENU Tab_m_trd_2
//{
//    LABEL   [trans2];
//    ITEMS
//    {
//        trans1_TT_2_st_rev,
//        trans1_TT_2_lin_type  (READ_ONLY),
//        trans1_TT_2_primary_value_unit  (READ_ONLY),
//        trans1_TT_2_sensor_measure_type  (READ_ONLY),
//        trans1_TT_2_input_range  (READ_ONLY),
//        trans1_TT_2_lower_sensor_limit  (READ_ONLY),
//        trans1_TT_2_upper_sensor_limit  (READ_ONLY)
//    }
//}
//
//MENU Tab_m_trd
//{
//    LABEL   "Tansducer (2)";
//    ITEMS
//    {
//        Tab_m_trd_1,
//        Tab_m_trd_2
//    }
//}

MENU Tab_m_AI
{
    LABEL   "Analog Input (4)";
    ITEMS
    {
        Tab_m_AI_1,
        Tab_m_AI_2,
        Tab_m_AI_3,
        Tab_m_AI_4
    }
}
METHOD std_NodeAddress
{
    LABEL        [menu_Device_NodeAddress];
    DEFINITION
    {
    }
}

METHOD std_LoadinDevice
{
    LABEL        [menu_Device_LoadinDevice];
    DEFINITION
    {
    }
}

METHOD std_LoadinPC
{
    LABEL        [menu_Device_LoadinPC];
    DEFINITION
    {
    }
}

METHOD std_Funktionsleiste
{
    LABEL        [menu_View_Toolbar];
    DEFINITION
    {
    }
}

METHOD std_Statuszeile
{
    LABEL        [menu_View_Statusbar];
    DEFINITION
    {
    }
}

METHOD std_Update
{
    LABEL        [menu_View_Update];
    DEFINITION
    {
    }
}

METHOD method_set
{
    LABEL        [MC_Write];
    HELP         [transfer_help];
    DEFINITION
    {
    }
}

METHOD  method_pre_write_phys_write_locking
{
    LABEL   [method_pre_write_phys_write_locking];
    DEFINITION
    {
        int ret;
        ReadCommand (read_phys_write_locking);
        if ( phys_write_locking == 0 )
        {
            ret = ACKNOWLEDGE([label_DeviceIsWriteProtected]);
            if (ret) process_abort();
        }
    }
}
